<?php
if (file_exists('../db.php')) {
  require_once('../db.php');
} elseif (file_exists('../common/db.php')) {
  require_once('../common/db.php');
} else {
  echo "<p><strong>Error:</strong> Cannot find the database settings, please make sure have did not remove your old config file</p>";
}
require_once('../options.php');
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Viewfinder Mailing List Upgrade</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css" >
body {
  margin: 0;
	padding: 0;
	background: #fff;
	color: 0;
	font-size: 67%;
	font-family: verdana, helvetica, sans-serif;
	text-align: center;
}

a {
	color: #df1111;
	text-decoration: none;
}

a:hover, a:visited {
  color: #ADAE8C;
	text-decoration: underline;
}

img {
  border: 0;
}

code {
  font-size: 1.3em;
}

#container {
  width: 500px;
  margin: 10px auto;
	padding: 0;
  background: #fff;
	text-align: left;
}

#header {
  margin: 0;
	padding: 0;
	height: 50px;
	border-bottom: 1px solid #df0000;
}

h1 {
  margin: 1em 0 0.2em 0;
  font-family: arial, helvetica, sans serif;
	font-size: 220%;
	font-weight: normal;
	color: #df1111;
}

.indent {
  margin: 0 0 1em 3em;
}

form {
	margin: 3em 0;
}

label {
  float: left;
  width: 16em;
	margin: 0 0 1em 0;
	padding: 0;
	font-weight: bold;
}

input {
  width: 200px;
	margin: 0 0 1em 0;
	padding: 0;
}

textarea {
  width: 300px;
}

#submit {
  width: 8em;
}

#footer {
  margin: 20px 0 0 0;
	padding: 0;
  text-align: center;
	font-size: 90%;
	color: #808080;
}
</style>
</head>

<body id="home">

<div id="container">

<div id="header">
<a href="http://www.viewfinderdesign.co.uk/"><img src="../images/vmllogo.gif" alt="Logo - click to visit Viewfinder Design" /></a>
</div> <!-- Header -->
<?php
if ($_GET['step'] == '2') {
  print("<h1>Upgrade (part 2)</h1>");
	/* Check for previous install */
	$installed = mysql_query("SELECT * FROM vml_users");
  if (!$installed) {
		echo "<p><strong>Previous Install Not Found</strong></p>\n<p>Either the settings in the config file are wrong or you have not previously installed VML.  If you have not installed VML before, please use the <a href=\"install.php\">installation option</a>.</p>\n<p><a href=\"javascript:history.go(-1)\">Back</a> or <a href=\"vml-admin/login.php\">Admin Login</a></p>";
    exit;  
  }
	/* Temporarily hold old data */
	$table_options = mysql_query("SELECT * FROM vml_options");
	echo "<p>Options table loaded</p>";
	$table_archive = mysql_query("SELECT * FROM vml_archive");
	echo "<p>Archive table loaded</p>";
	$table_mailinglist = mysql_query("SELECT * FROM vml_mailinglist");
	echo "<p>Mailing List table loaded</p>";
	$table_template = mysql_query("SELECT * FROM vml_template");
	echo "<p>Template table loaded</p>";
	$table_users = mysql_query("SELECT * FROM vml_users");
	echo "<p>Users table loaded</p>";
	$result = mysql_query("DROP TABLE IF EXISTS vml_options");
	$result = mysql_query("DROP TABLE IF EXISTS vml_archive");
	$result = mysql_query("DROP TABLE IF EXISTS vml_mailinglist");
	$result = mysql_query("DROP TABLE IF EXISTS vml_template");
	$result = mysql_query("DROP TABLE IF EXISTS vml_users");
	echo "<p>Old tables deleted, creating new tables.</p>";
  /* Create Tables */
  $sql = mysql_query("CREATE TABLE `vml_archive` (
  `uid` int(6) unsigned zerofill NOT NULL auto_increment,
  `subject` varchar(255) default NULL,
  `html` longtext,
  `plaintext` longtext,
  `embed` char(1) NOT NULL default '',
  `listid` int(4) unsigned zerofill NOT NULL default '0000',
  `date` datetime default NULL,
  `status` varchar(5) NOT NULL default '',
  `htmltotal` varchar(7) NOT NULL default '',
  `texttotal` varchar(7) NOT NULL default '',
  `opens` varchar(7) NOT NULL default '',
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `uid` (`uid`)
) TYPE=MyISAM");
  if ($sql) {
    $verbose = "<p>New archives table created.</p>";
	} else { $verbose = "<p><strong>Error:</strong> Archives table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_mailinglists` (
  `uid` int(4) unsigned zerofill NOT NULL auto_increment,
  `list_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`uid`)
) TYPE=MyISAM");
  if ($sql) {
    $verbose .= "<p>New mailingList table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> MailingList table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_options` (
  `sitename` varchar(255) default NULL,
  `siteaddress` varchar(255) default NULL,
  `email` varchar(50) default NULL,
  `fromemail` varchar(50) default NULL,
  `notification` int(1) NOT NULL default '1',
  `mailtype` varchar(4) NOT NULL default 'text',
  `popup` int(1) NOT NULL default '0',
  `validation` int(1) NOT NULL default '1',
  `throttlerate` varchar(4) NOT NULL default ''
) TYPE=MyISAM");
  if ($sql) {
    $verbose .= "<p>New options table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Options table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_templates` (
  `tid` int(3) unsigned zerofill NOT NULL auto_increment,
  `template_name` varchar(255) default NULL,
  `template` longtext,
  PRIMARY KEY  (`tid`)
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>New template table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Template table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_users` (
  `username` varchar(50) default NULL,
  `password` varchar(32) default NULL,
  `user_level` int(2) unsigned NOT NULL default '0',
  UNIQUE KEY `username` (`username`)
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>New users table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Users table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_custom_fields` (
  `cid` int(7) unsigned zerofill NOT NULL auto_increment,
  `subid` int(7) unsigned zerofill NOT NULL default '0000000',
  `listid` int(4) unsigned zerofill NOT NULL default '0000',
  `field_name` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`cid`),
  UNIQUE KEY `subid` (`subid`,`listid`,`field_name`)
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>Custom table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Custom Fields table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_send_queue` (
  `subid` int(7) unsigned zerofill NOT NULL default '0000000',
  `recipient_fname` varchar(255) NOT NULL default '',
  `recipient_lname` varchar(255) NOT NULL default '',
  `email_address` varchar(255) NOT NULL default '',
  `format` varchar(4) NOT NULL default '',
  `newsletterid` int(6) unsigned zerofill NOT NULL default '000000',
  `send_time` datetime NOT NULL default '0000-00-00 00:00:00'
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>Send Queue table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Send Queue table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_subscribed_to` (
  `subscriberid` int(7) unsigned zerofill NOT NULL default '0000000',
  `listid` int(4) unsigned zerofill NOT NULL default '0000',
  UNIQUE KEY `subscriberid` (`subscriberid`,`listid`)
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>Subscribed To table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Subscribed To table not created.</p>"; }
	$sql = mysql_query("CREATE TABLE `vml_subscribers` (
  `uid` int(7) unsigned zerofill NOT NULL auto_increment,
  `first_name` varchar(30) default NULL,
  `last_name` varchar(30) default NULL,
  `email` varchar(50) NOT NULL default '',
  `format` varchar(4) default NULL,
  `validated` int(1) default '0',
  PRIMARY KEY  (`email`),
  UNIQUE KEY `uid` (`uid`)
) TYPE=MyISAM");
	if ($sql) {
    $verbose .= "<p>Subscribers table created.</p>";
	} else { $verbose .= "<p><strong>Error:</strong> Subscribers table not created.</p>"; }
	echo "$verbose";
	/* Install old data */
	$optionsrow = mysql_fetch_array($table_options);
	$result = mysql_query("INSERT INTO vml_options SET sitename='$optionsrow[sitename]',siteaddress='$optionsrow[siteaddress]',email='$optionsrow[email]',fromemail='$optionsrow[fromemail]',notification='$optionsrow[notification]',mailtype='$optionsrow[mailtype]',popup='$optionsrow[popup]',validation='$optionsrow[validation]',throttlerate='50'");
  $usersrow = mysql_fetch_array($table_users);
	$result = mysql_query("INSERT INTO vml_users SET username='$usersrow[username]',password='$usersrow[password]',user_level='5'");
	while ($archiverows = mysql_fetch_array($table_archive)) {
	  $result = mysql_query("INSERT INTO vml_archive SET uid='$archiverows[uid]',subject='$archiverows[subject]',plaintext='$archiverows[content]'");
	}
	$createlist = mysql_query("INSERT INTO vml_mailinglists SET list_name='Imported List'");
	$insertlistid = mysql_insert_id();
	while ($subsrow = mysql_fetch_array($table_mailinglist)) {
	  $result = mysql_query("INSERT INTO vml_subscribers SET uid='$subsrow[uid]',email='$subsrow[email]',validated='$subsrow[validated]',format='html'");
    $insertsubid = mysql_insert_id();
    $sublist = mysql_query("INSERT INTO vml_subscribed_to SET subscriberid='$insertsubid',listid='$insertlistid'");
	}
	$templatesrow = mysql_fetch_array($table_template);
	$completetemplate = $templatesrow['header'].$templatesrow['footer'];
	$result = mysql_query("INSERT INTO vml_templates SET template_name='Default (Imported)',template='$completetemplate'");
	$present = strpos($verbose, 'Error');
	if ($present == false) {
?>
<p>Upgrade complete.<p>
<p>Before proceeding you need to open <strong>config.php</strong> and replace the contents with the following:</p>
<p>You should now be able to login via the <a href="login.php" title="head to the admin section">admin section</a> with the same details as before.</p>
<?php
  }
  else {
  print("<p>Some errors have been detected, please go back and check the settings you provided.</p>");
  }
}
else {
?>
<h1>Upgrade (part 1)</h1>

<p>Welcome to Viewfinder Mailing List, to upgrade an older version of VML, simply <a href="upgrade.php?step=2">click here</a>.</p>
<?php
}
?>

<div id="footer">
<p>Viewfinder Mailing List by<br/><a href="http://www.viewfinderdesign.co.uk" title="Visit Viewfinder Design"><img src="../images/vfdlogo.gif" alt="Viewfinder Design Logo" style="margin-top:5px; border: none;" /></a></p>
</div> <!-- Footer -->

</div> <!-- Container -->

</body>
</html>
